unit ChangeIcDialog;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms, Dialogs;

type
  TChangeIcDialog = class(TComponent)
  private
    { Private declarations }
    FFileName: string;
    FIconIndex: Integer;
    FCaption: string;
  protected
    { Protected declarations }
  public
    { Public declarations }
    function Execute: Boolean; virtual;
    constructor Create(aOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Caption: string read FCaption write FCaption;
    property FileName: string read FFileName write FFileName;
    property IconIndex: Integer read FIconIndex write FIconIndex;
    { Published declarations }
  end;

procedure Register;

implementation

{$R ChangeIcDialog.res}

uses ChngIcon;

procedure Register;
begin
  RegisterComponents('Dialogs', [TChangeIcDialog]);
end;

constructor TChangeIcDialog.Create(aOwner: TComponent);
begin
    inherited Create(aOwner);
    FCaption:= 'Change icon';
    FFILENAME:= 'C:\Windows\System\Shell32.dll';
end;

destructor TChangeIcDialog.Destroy;
begin
  inherited Destroy;
end;

function TChangeIcDialog.Execute: Boolean;
begin
  IconDlg := TIconDlg.Create(Application);
  with IconDlg do
  begin
    try
    IconDlg.Caption:= FCaption;
    IconDlg.IconListBox1.FileName:= FFileName;
    IconDlg.Edit1.Text:= IconDlg.IconListBox1.FileName;
    IconDlg.IconListBox1.ItemIndex:= FIconIndex;
    Result := (ShowModal = IDOK);
    finally
    FFileName:= IconDlg.IconListBox1.FileName;
    FIconIndex:= IconDlg.IconListBox1.ItemIndex;
    Free;
    end;
    end;
    end;
    end.
